/*
 *  audio.h
 *
 *  Copyright (C) Gerhard Monzel - October 2003
 *
 *  This file is part of lve, a linux mpeg video editor
 *      
 *  lve tools are free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  lve is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */
#ifndef _AUDIO_H
#define _AUDIO_H 1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <inttypes.h>
#include <SDL/SDL.h>
#include "decoder.h"

#define MIN_VIDEO_FR    20
#define MAX_SAMPLE_RATE 48000
#define MAX_SAMPLES_PVF (MAX_SAMPLE_RATE / MIN_VIDEO_FR)
#define MIN_OUT_SAMPLES 2048  
#define MAX_A52_SAMPLES 1536
#define MAX_SAMPLE_BUF  (3*MAX_A52_SAMPLES)      

typedef struct
{
  T_AUDIO_DEC *a_decoder;
  int         align;  
} T_AUDIO_CTX;

class T_AUDIO_OUT
{
  private:
    int           audio_open;
    SDL_AudioSpec *audio_spec;
    //short         *sample_buf;
    T_AUDIO_CTX   audio_ctx;
    
  private:  
    void cleanup(void);
    
  public: 
    T_AUDIO_OUT(void);
    ~T_AUDIO_OUT();  

    void setup(T_MPEG_DEC *decoder);
    void switchOff(void);
    int  open(void);
    void close(void);

    int  isOpen(void);
    void waitBuffer(void);
};

#endif

