/*
 *  edit.h
 *
 *  Copyright (C) Gerhard Monzel - October 2003
 *
 *  This file is part of lve, a linux mpeg video editor
 *      
 *  lve tools are free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  lve is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */
#ifndef _EDIT_H
#define _EDIT_H 1

#include "scenelst.h"
#include "media.h"
#include "media_buf.h"

class T_LST_EDIT : public T_LST_SCENE
{
  public:
    T_LST_EDIT() : T_LST_SCENE() 
    {
      mb_cnt = 0;
    };

    virtual T_MEMBER *InsertMember(T_MEMBER *mb_new, T_MEMBER *mb);
    virtual T_MEMBER *AppendMember(T_MEMBER *mb_new);
    virtual void      RemoveMember(T_MEMBER *mb_cut, int del = 1);
    
    void TrimMember(T_MB_EDIT *mb, int side, int draw_thumb = 1);
    
  protected: 
    virtual void      Reset();
    virtual int       SaveHeader(FILE *lst_file);
    virtual int       LoadHeader(FILE *lst_file); 
    virtual void      CommitHeader(void);   
    virtual T_MEMBER *CreateMember(int n);
};

class T_MB_EDIT : public T_MB_SCENE
{
  friend class T_LST_EDIT;
  friend class T_MB_MEDIA;

  public:
    T_MB_EDIT::T_MB_EDIT(T_LVE_CTX *ctx, int num)
                        : T_MB_SCENE(ctx, num)
    {};

    virtual T_MB_SCENE *Dup(void);
 
  protected:
    virtual void Save(FILE *lst_file);
    virtual int  Load(FILE *lst_file);
    
    int          TrimLeft(void);
    int          TrimRight(void);
};

#endif // _EDIT_H
