/*
 *  ffmpeg_aenc.h
 *
 *  Copyright (C) Gerhard Monzel - October 2003
 *
 *  This file is part of lve, a linux mpeg video editor
 *      
 *  lve tools are free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  lve is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */
#ifndef _FFMPEG_AENC_H
#define _FFMPEG_AENC_H 1

#include <stdlib.h>
#include "avcodec.h"

#undef __EXTERN
#ifndef _FFMPEG_AENC_
#define __EXTERN extern 
#else
#define __EXTERN
#endif

#define SAMPLE_BUF_LEN  (12*1920)

typedef struct
{
  AVCodecContext *a_ctx;
  int            bytes_avail;
  int            encoded_fs;
  int            sample_bytes_paf;
  uint8_t        sample_buf[SAMPLE_BUF_LEN];
} EncoderCtx;

__EXTERN void       ffmpeg_aencode_close(EncoderCtx *enc);
__EXTERN EncoderCtx *ffmpeg_aencode_open(int bit_rate, int sample_rate);
__EXTERN int        ffmpeg_aencode(EncoderCtx *enc, 
                      uint8_t *iobuf, int iobuf_len, int max_iobuf_len);  

#endif
