/*
 *  lve_ctx.h
 *
 *  Copyright (C) Gerhard Monzel - October 2003
 *
 *  This file is part of lve, a linux mpeg video editor
 *      
 *  lve tools are free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  lve is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */
#ifndef _LVE_CTX_H
#define _LVE_CTX_H 1

#include <SDL/SDL.h>
#include "frame_srv.h"
#include "decoder.h"
#include "img_format.h"

typedef struct
{
  T_FRAME_SRV   *file;
  int           v_stream;
  int           a_stream;
  
  SDL_Surface*  screen;
  Uint32	w;
  Uint32	h;
  Uint8		**page;
  SDL_Overlay	*ov;
  Uint32	ov_fmt;
  
  int		action;
  int           action_sav;
  int		run_once;
  int           ntsc;        // only to calculate durations from count of frames
  
  Uint32	iv;
  int		refresh_bg;
  int           reset_ov;

  int		media_id;
  int 		adj_pos;     // 1="with jump", 2="without jump", 3="jump to scene start"
  int           need_thumb;
    
  int		act_frame;
  int		act_real;
  
  int		start_real;
  int		end_real;
  
  int		start;
  int		end;
  
  int		dist_sum;
  int           step;

  int           avs_dp;   
} T_LVE_CTX;

#endif
