/*
 *  media.h
 *
 *  Copyright (C) Gerhard Monzel - October 2003
 *
 *  This file is part of lve, a linux mpeg video editor
 *      
 *  lve tools are free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  lve is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */
#ifndef _MEDIA_H
#define _MEDIA_H 1

#include "scenelst.h"
#include "edit.h"

class T_LST_MEDIA : public T_LST_SCENE
{
  public:
    T_LST_MEDIA::T_LST_MEDIA() : T_LST_SCENE() {};
    
    T_MEMBER *LoadMedia(char *name, int a_stream, int v_stream);
    
  protected: 
    virtual void      Reset(void);
    virtual int       SaveHeader(FILE *lst_file);
    virtual void      CommitHeader(void);
    virtual int       LoadHeader(FILE *lst_file);    
    virtual T_MEMBER *CreateMember(int n);
};

class T_MB_MEDIA : public T_MB_SCENE
{
  friend class T_LST_MEDIA;
  friend class T_MB_EDIT;

  public:
    T_MB_MEDIA::T_MB_MEDIA(T_LVE_CTX *ctx, int num)
                          : T_MB_SCENE(ctx, num)
    {};

    virtual T_MB_SCENE *Dup(void);
    
    T_MB_MEDIA *Split(void);
    void       Join(T_MB_SCENE *mb);

  protected:    
    virtual void Save(FILE *lst_file);
    virtual int  Load(FILE *lst_file);
};

#endif // _MEDIA_H
