/*
 *  media_buf.h
 *
 *  Copyright (C) Gerhard Monzel - October 2003
 *
 *  This file is part of lve, a linux mpeg video editor
 *      
 *  lve tools are free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  lve is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */
#ifndef _MEDIA_BUF_H
#define _MEDIA_BUF_H 1

#include <inttypes.h>

#define MAGIC_LEN	8
#define MEDIA_BUF_MAGIC "LVEMEDV6"  // exactly 8 char needed !
#define EDIT_BUF_MAGIC  "LVEEDTV6"

#define  BMP_TH_W     88
#define  BMP_TH_H     72
#define  BMP_TH_W2    (BMP_TH_W/2)
#define  BMP_TH_H2    (BMP_TH_H/2)
#define  BMP_TH_LEN   (BMP_TH_W*BMP_TH_H*2)

typedef struct
{
  char   magic[MAGIC_LEN+1];
  int    mb_cnt;
  int    dist_sum;
  int    output_size_mb;
} T_MEDIA_HDR;

typedef struct 
{
  int      media_id;
  int      vstream;
  int      astream;
  int      start_real;
  int      end_real;
  int      dist;
  int      start;
  int      end;
  int      avs_dp;
  char     fname[1024];
  int8_t   bmp_thumb[BMP_TH_LEN];
} T_MEDIA_BUF;

#endif
