/*
 *  mediafile.h
 *
 *  Copyright (C) Gerhard Monzel - October 2003
 *
 *  This file is part of lve, a linux mpeg video editor
 *      
 *  lve tools are free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  lve is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */
#ifndef _MEDIAFILE_H
#define _MEDIAFILE_H 1

#define MAX_MEDIA_CNT 128

class TMediaFile
{
  private:
    static TMediaFile *list[MAX_MEDIA_CNT];
    static int        count;
 
    int    id;
    char   fn[1024];
    
  protected:
    int    refCount;  

  public:
    char        isOpen;
    int         videoW;
    int         videoH;
    int         ovFmt;
    void        *frmSrv;

  protected:
    TMediaFile(char *_fn, int _id);
    static TMediaFile **getList(void); 
    
  public:
    static TMediaFile *createMDF(char *fname);
    static void       releaseMDF(TMediaFile* mdf);
    static void       resetList(void);

    ~TMediaFile();
    
    void       cleanup(void);
    TMediaFile *dup(void);
    void       showInfo(void);
    int        getId(void);
    char       *getName(void);
};

#endif // _MEDIAFILE_H
// eof
